<template>
  <div>
    <div class="row">
      <div class="col-xs-12 col-md-6">
        <el-input
          v-model="search"
          placeholder="Rechercher"
        />
      </div>
      <div class="col-xs-12 col-md-6">
        <click-button
          @click="clearFilter"
        >
          <template #content>
            Effacer tous les filtres
          </template>
        </click-button>
        <!--        <el-button @click="toggleSelection()">-->
        <!--          Effacer la sélection-->
        <!--        </el-button>-->
      </div>
    </div>
    <div class="row">
      <el-table
        ref="businessesTable"
        :data="pagedAndFilteredBusinesses"
        :default-sort="{prop: 'createdAt', order: 'descending'}"
        border
        stripe
        style="width: 100%"
        @selection-change="handleSelectionChange"
      >
        <!--        <el-table-column-->
        <!--          type="selection"-->
        <!--          width="55"-->
        <!--        />-->
        <el-table-column
          prop="createdAt"
          label="Inscrit le"
          sortable="custom"
          width="180"
        >
          <template slot-scope="scope">
            {{ scope.row.createdAt.date | beautifulDate }}
          </template>
        </el-table-column>
        <el-table-column
          prop="email"
          label="Email"
          sortable
          width="180"
        />
        <el-table-column
          prop="id"
          label="Sirens"
        >
          <template slot-scope="scope">
            <p v-if="scope.row.sirens.length > 3">
              <el-button
                type="text"
                @click="seeMoreSirens(scope.row.sirens)"
              >
                Voir les {{ scope.row.sirens.length }} éléments
              </el-button>
            </p>
            <p
              v-for="(siren, sirenIndex) in scope.row.sirens"
              v-else
              :key="siren.id"
            >
              {{ scope.row.sirens[sirenIndex].number }}
            </p>
          </template>
        </el-table-column>
        <el-table-column
          prop="id"
          label="Équipe(s)"
        >
          <template slot-scope="scope">
            <p v-if="scope.row.teams.length > 3">
              <el-button
                type="text"
                @click="seeMoreTeams(scope.row.teams)"
              >
                Voir les {{ scope.row.teams.length }} éléments
              </el-button>
            </p>
            <p
              v-for="(team, teamIndex) in scope.row.teams"
              v-else
              :key="team.id"
            >
              {{ scope.row.teams[teamIndex].description }}
            </p>
          </template>
        </el-table-column>
        <el-table-column
          prop="connect"
          label="Se connecter en tant que"
        >
          <template slot-scope="scope">
            <click-button
              :disabled="isLoading"
              @click="impersonate(scope.row.email)"
            >
              <template #content>
                <ghost-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <div class="row">
      <el-pagination
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next"
        :total="filteredBusinesses.length"
        @current-change="handleCurrentChange"
      />
    </div>
  </div>
</template>

<script>
import {mapActions, mapGetters} from "vuex";
import GhostIcon from "../../../components/Icon/GhostIcon";
import ClickButton from "../../../components/Button/ClickButton";

export default {
  name: "ManagerBusinessTable",
  components: {ClickButton, GhostIcon},
  data() {
    return {
      search: '',
      multipleSelection: [],
      currentPage: 1,
      pageSize: 10
    }
  },
  computed: {
    pagedAndFilteredBusinesses() {
      return !this.search
        ?
        this.businesses.slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)
        :
        this.businesses.filter(business => business.email.toLowerCase().includes(this.search.toLowerCase())).slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)

    },
    filteredBusinesses() {
      return this.search ? this.businesses.filter(business => business.email.toLowerCase().includes(this.search.toLowerCase())) : this.businesses
    },
    ...mapGetters([
      'isLoading',
      'businesses'
    ])
  },
  methods: {
    ...mapActions([
      'loadingStarts',
      'loadingEnds',
      'impersonate'
    ]),
    handleCurrentChange(val) {
      this.currentPage = val
    },
    toggleSelection(rows) {
      if (rows) {
        rows.forEach(row => {
          this.$refs.businessesTable.toggleRowSelection(row);
        });
      } else {
        this.$refs.businessesTable.clearSelection();
      }
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    filterHandler(value, row, column) {
      const property = column['property'];
      return row[property] === value;
    },
    clearFilter() {
      this.$refs.businessesTable.clearFilter();
    },
    seeMoreSirens(sirens) {
      let text = ''
      sirens.forEach(siren => {
        text+= siren.number+', '
      });
      text = text.substring(0, text.length-2)
      this.$alert(text, 'Liste des sirens', {
        confirmButtonText: 'Retour'
      });
    },
  }
}
</script>

<style scoped>
  .row {
    margin-top: 2vh;
  }
</style>